type 'a list =
  | Nil
  | Cons of 'a * 'a list

let rec _append m n = match m with
    | Nil -> n
    | Cons(_, m') -> Cons(#2, _append m' n)

let rec append m n = match m with
    | Nil -> n
    | Cons(x, m') -> Cons(x, append m' n)

let rec add m n = match m with
    | Z -> n
    | S m' -> S (add m' n)

let rec _add m n = match (orn-match #4) m with
    | Z_skel -> n
    | S_skel m' -> (orn-cons #1) (S_skel (_add m' n)) #2

let rec append2 m n = match m with
    | Nil -> n
    | Cons(x, m') -> Cons(x, append2 m' n)

let _double n = (lifting #3 of add) n n

let double_list n = append n n

let double n = add n n

type bool =
  | False
  | True

let _zero_bool = match #2 with
    | Left _ -> True
    | Right _ -> False

let true = True

let _one_bool = <absurd>

type nattwo =
  | Z01
  | S0 of nattwo
  | S1 of nattwo

let one' = S Z

let rec add_twice m n = match m with
    | Z -> n
    | S m'' -> S (S (add_twice m'' n))
