
# 14 "unfolding_tuple.tex"
type 'a list =
  | Nil
  | Cons of 'a * 'a list

# 21 "unfolding_tuple.tex"
let rec map f x =
  match x with
  | Nil -> Nil
  | Cons(x,xs) -> Cons(f x, map f xs)

# 29 "unfolding_tuple.tex"
type 'a vec3 = Vec3 of 'a * 'a * 'a

# 34 "unfolding_tuple.tex"
type ornament 'a list3 : 'a list => 'a vec3 with
| Nil => ~
       | Cons(x, (y, z) : 'a list2) => Vec3(x, y, z)
and 'a list2 : 'a list => 'a * 'a with
  | Nil => ~
         | Cons(y, z : 'a list1) => (y, z)
and 'a list1 : 'a list => 'a with
  | Nil => ~
         | Cons(z, () : 'a list0) => z
and 'a list0 : 'a list => () with
  | Nil => ()
  | Cons(x, xs) => ~

# 49 "unfolding_tuple.tex"
#(push_env)
let map_tuple = lifting map : ('a -> 'b) -> 'a list3 -> 'b list3
#(pop_env)

# 69 "unfolding_tuple.tex"
#(mode inline)
let map_tuple = lifting map : ('a -> 'b) -> 'a list3 -> 'b list3
