type nat = Z | S of nat

type bool = True | False
type num = Z' | S' of bool * num

type ornament nat_to_num : nat => num with
  | Z => Z'
  | S z => S' (_, z) when z : nat_to_num

(* Succeeds *)
let rec id_nat y = match y with | Z -> Z | S z -> S z
let id_num = lifting id_nat : nat_to_num -> nat_to_num
     with #2 <- (match y with S' (x1, _) -> x1)


(* Fails  with incomplete pattern matching.
   because there is a variable capture *)
let rec id_nat x = match x with | Z -> Z | S z -> S z
let id_num = lifting id_nat : nat_to_num -> nat_to_num
let id_num = lifting id_nat : nat_to_num -> nat_to_num
   with #2 <- (match x with S' (x1, _) -> x1)
       

