
# 13 "natlist.tex"
type nat =
  | Z
  | S of nat

# 18 "natlist.tex"
let rec add m n = match m with
  | Z -> n
  | S m' -> S (add m' n)

# 60 "natlist.tex"
let rec map_nat f n = match n with
  | Z -> Z
  | S n' -> S (map_nat f n')

# 76 "natlist.tex"
let rec fold_nat s z n = match n with
  | Z -> z
  | S n' -> s (fold_nat s z n')
